2018-07-22 14:40 CEST

View Issue Details Jump to Notes ]
IDProjectCategoryView StatusLast Update
0004759Talerexchangepublic2018-04-15 20:37
ReporterMarcello Stanisci 
Assigned ToMarcello Stanisci 
PrioritynormalSeverityfeatureReproducibilityhave not tried
StatusresolvedResolutionwon't fix 
Product Version0.1 
Target Version0.6Fixed in Version0.6 
Summary0004759: Fake errors needed
DescriptionBugs as 0004732 need errors to be correctly tested, so the exchange should
provide some way of generating errors. Moreover, some of them should not occur
always, as otherwise we can't test other stuff. I suggest a mix of config values
and URL parameters, like:

[exchange]
..
debug = "true";
..

and a URL like /track/transfer?wtid=x&error=yes. So if 'debug' is set, then the
exchange will return a conflict for wtid 'x'; if 'debug' is not set, then this is
just a malformed URL (so we keep production exchange safe).
TagsNo tags attached.
Attached Files

-Relationships Relation Graph ] Dependency Graph ]
child of 0004454resolvedMarcello Stanisci fault injection for all GNU Taler APIs 
+Relationships

-Notes

~0011416

Christian Grothoff (manager)

I agree with testing, but disagree with the proposed method. We should not complicate the exchange C code with such test logic, it will make it harder to read, audit and debug.

Instead, we should (eventually) have an HTTP reverse proxy that injects such faults as a "man in the middle" for testing.

Here, I would additionally suggest that if a test wants to tell the proxy to inject errors, it should be done via HTTP headers, not by changing the URL.

~0012900

Marcello Stanisci (manager)

We opted for a HTTP proxy and NOT to touch anything in the tested components.
+Notes

-Issue History
Date Modified Username Field Change
2016-11-03 16:21 Marcello Stanisci New Issue
2016-11-03 16:21 Marcello Stanisci Status new => assigned
2016-11-03 16:21 Marcello Stanisci Assigned To => Christian Grothoff
2016-11-03 17:59 Christian Grothoff Note Added: 0011416
2016-11-03 17:59 Christian Grothoff Relationship added child of 0004454
2016-11-03 18:00 Christian Grothoff Assigned To Christian Grothoff =>
2016-11-03 18:00 Christian Grothoff Priority low => normal
2016-11-03 18:00 Christian Grothoff Severity minor => feature
2016-11-03 18:00 Christian Grothoff Status assigned => confirmed
2016-11-03 18:00 Christian Grothoff Product Version => 0.1
2016-11-03 18:00 Christian Grothoff Target Version => 0.6
2018-03-27 11:49 Marcello Stanisci Assigned To => Marcello Stanisci
2018-03-27 11:49 Marcello Stanisci Status confirmed => closed
2018-03-27 11:49 Marcello Stanisci Resolution open => won't fix
2018-03-27 11:49 Marcello Stanisci Note Added: 0012900
2018-04-15 20:37 Christian Grothoff Status closed => resolved
2018-04-15 20:37 Christian Grothoff Fixed in Version => 0.6
+Issue History